<template>
    <single-pane :capt="dictionaryRu.title" class="page-card-constructor">
        <ob-table
                :columns="cardColumns"
                :items="gridData"
                :show-add-button="true"
                :functional-panel="true"
                @select="openPopup"
                @add="openAddPopup"
        >
        </ob-table>
        <SBCardContructorPopup ref="CardContructorPopup" @saved="fetchFields"/>
    </single-pane>
</template>

<script>
    import SinglePane from "common-components/src/obComponents/obSinglePanels";
    import ObTable from "common-components/src/obComponents/obTable";
    import SBCardContructorPopup from './modal/CardContructorPopup'
    import TableLayoutMixin from '@/mixins/table-layout-mixin'
    import api from '@/api'
    import moment from 'moment'
    import { dictionaryDefault } from '@/translations/ru/default'
    import { dictionary } from '@/translations/ru/settings__sb_settings__resource_fields'

    export default {
        name: 'ResourceConstructor',
        components: {
            ObTable,
            SinglePane,
            SBCardContructorPopup
        },
        mixins: [
            TableLayoutMixin
        ],
        data () {
            return {
                gridData: [],
                dictionaryRu: Object.assign(dictionary, dictionaryDefault)
            }
        },
        computed: {
            cardColumns () {
                return [
                    {
                        title: 'Наименование поля',
                        key: 'title'
                    },
                    {
                        title: this.dictionaryRu.columns.class,
                        key: 'class.title',
                        html: (data) => {
                            return data.class && data.class.title
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.type,
                        key: 'type.title',
                        html: (data) => {
                            return data.species && data.species.title
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.subtype,
                        key: 'subtype.title',
                        html: (data) =>  {
                            return data.subtype?data.subtype && data.subtype.title:''
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.country,
                        key: 'countries',
                        html: (data) =>  {
                            return data.countries && data.countries.map(c => c.name).join(', ')
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.status,
                        key: 'is_active',
                        html: (data) =>  {
                            if (data.deleted) {
                                return '<div class="not-active">' + this.dictionaryRu.status.inactive + '</div>';
                            }
                            return '<div>' + this.dictionaryRu.status.active + '</div>';
                        }
                    },
                    {
                        title: 'Дата',
                        key: 'created_at',
                        html: (data) =>  {
                            return data.created_at ? moment(data.created_at).format('DD.MM.YYYY') : ''
                        }
                    }
                ]
            },
        },
        methods: {
            openAddPopup () {
                this.$refs.CardContructorPopup.open()
            },
            onLoad () {

            },
            updateFilter () {

            },
            async openPopup (data) {
                try {
                    const res = await api.cardField.getResource(data.uuid)
                    const risks_list = await api.card.getRiskResource(data.uuid)
                    res.uuid = data.uuid
                    this.$refs.CardContructorPopup.open({...res, risks_list})
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }
            },
            async fetchFields () {
                try {
                    this.gridData = await api.cardField.fetchResource()
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }
            },

        },
        mounted () {
            this.fetchFields()
        }
    }
</script>

